.NOLIST                                     ; wyczenie z raportu z kompilacji
.INCLUDE    "tn2313def.inc"         ; doczonego pliku AT90S2313def.inc
.list

;-----------------------------------------------------------------------------
.cseg
.org	0


rcall Main;
;-----------------------------------------------------------------------------


.INCLUDE    "ds1302.asm"         ; doczonego pliku AT90S2313def.inc
.INCLUDE    "rozbij.asm"
.INCLUDE    "screen.asm"

;-----------------------------------------------------------------------------
Main:

	;---------------------------
	;flaga zapisu (ustaw na 0) > moge wprowadza zmiany
	ldi command_byte,	CMD | CLOCK | ADDR_WPFLAG | WRITE; komenda usuwajca WP
	ldi data_byte,		0b00000000	;wartosc
		rcall DS1302_SendCode
	clr command_byte
	clr data_byte
	;-------------------------

	;---------------------------
	;usuwanie flagi CH - start zegara + zeruje sekundy
	ldi command_byte,	CMD | CLOCK | ADDR_CHFLAG | WRITE	; komenda usuwajca WP
	ldi data_byte,0b00000000								;wartosc
		rcall DS1302_SendCode
	clr command_byte
	clr data_byte
	;----------------------------

	;=======================
	;ustawiam czas na
	;12:34 56'
		;---------------------------
		;usuwanie godzine - (12)
		ldi command_byte,	CMD | CLOCK | ADDR_HRS | WRITE	; komenda usuwajca WP
		ldi data_byte,0b00010010								;wartosc
			rcall DS1302_SendCode
		clr command_byte
		clr data_byte
		;---------------------------

		;---------------------------
		;usuwanie minuty - (34)
		ldi command_byte,	CMD | CLOCK | ADDR_MIN | WRITE	; komenda usuwajca WP
		ldi data_byte,0b00110100								;wartosc
			rcall DS1302_SendCode
		clr command_byte
		clr data_byte
		;---------------------------

		;---------------------------
		;usuwanie sekundy - (56)
		ldi command_byte,	CMD | CLOCK | ADDR_SEC | WRITE	; komenda usuwajca WP
		ldi data_byte,0b01010110								;wartosc
			rcall DS1302_SendCode
		clr command_byte
		clr data_byte
		;---------------------------
	;=======================

	;inicjacja 2 dodatkowych ekranow
	sbi PORTA,		0
	sbi PORTA-1,	0

	sbi PORTA,		1
	sbi PORTA-1,	1
	;-------------------------------

	rcall EKRAN_INIT
	sbi PORTA-1,	0
	sbi PORTA-1,	1
	rcall EKRAN_TEST;
	cbi PORTA-1,	0
	cbi PORTA-1,	1
Main2:


	rcall CzytajSec;
	rcall CzytajMin;
	rcall CzytajHrs;

	;---------------------------
	push r21
	push r22

	LDI r21,200
	display_number_loop1:

			LDI r22,1
			display_number_loop2:



			;========================================================
			;---------------------------
			;godziny-dzieskiatki
			rcall EKRAN_INIT
	
			push r16
				mov r16, r24
				rcall EKRAN_DIS 
			pop r16

			sbi PORTA-1,	0
			rcall wait	;daj czas...
			rcall wait	;...na pokazanie - rozpalenie diody
			cbi PORTA-1,	0
			;--

			;---------------------------
			;godziny-jedno
			rcall EKRAN_INIT
	
			push r16
				mov r16, r25
				rcall EKRAN_DIS 
			pop r16

			sbi PORTA-1,	1
			rcall wait	;daj czas...
			rcall wait	;...na pokazanie - rozpalenie diody
			cbi PORTA-1,	1
			;--
			;========================================================

			;========================================================
			;---------------------------
			;min-dzieskiatki
			rcall EKRAN_INIT
	
			push r16
				mov r16, r28
				rcall EKRAN_DIS 
			pop r16

			rcall EKRAN_1_ON
			rcall wait	;daj czas...
			rcall wait	;...na pokazanie - rozpalenie diody
			rcall EKRAN_1_OFF
			;--

			;---------------------------
			;min-jedno
			rcall EKRAN_INIT
	
			push r16
				mov r16, r29
				rcall EKRAN_DIS 
			pop r16

			rcall EKRAN_2_ON
			rcall wait	;daj czas...
			rcall wait	;...na pokazanie - rozpalenie diody
			rcall EKRAN_2_OFF
			;--
			;========================================================

			;========================================================
				;---------------------------
				;sec-dzieskiatki
				rcall EKRAN_INIT
	
				push r16
					mov r16, r26
					rcall EKRAN_DIS 
				pop r16

				rcall EKRAN_3_ON
				rcall wait	;daj czas...
				rcall wait	;...na pokazanie - rozpalenie diody
				rcall EKRAN_3_OFF
				;--

				;---------------------------
				;sec-jednosci
				rcall EKRAN_INIT
			
				push r16
					mov r16, r27
					rcall EKRAN_DIS 
				pop r16

				rcall EKRAN_4_ON
				rcall wait	;daj czas...
				rcall wait	;...na pokazanie - rozpalenie diody
				rcall EKRAN_4_OFF
				;--
			;========================================================

			DEC r22; 1 takt 
			BRNE display_number_loop2

	DEC r21; 1 takt 
	BRNE display_number_loop1; 2 takty 

	pop r22
	pop r21	
	;---------------------------


rjmp  Main2
;-----------------------------------------------------------------------------

;odczekaj
wait:
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	nop
	nop
	nop
	nop
	nop
	nop
	nop
ret


CzytajSec:
	;---------------------------
	;odczytaj z RAM
	ldi command_byte,	CMD | CLOCK | ADDR_SEC | READ		; komenda usuwajca WP
	clr data_byte		 									;tu beda dane odczytane
	rcall DS1302_SendCode
	clr command_byte
	;---------------------------

	;;=================================================
	;wydobdz informacje
	clr r25
	clr r24
	;---------------------------
	;dziesiatki
	ldi r24,0b01110000 
	AND r24,data_byte ; 0b01110000 AND data_byte - maska
	LSR	r24
	LSR	r24
	LSR	r24
	LSR	r24

	;---------------------------
	;jednosci
	;ldi r22, 0b00001111 & data_byte; 0b00001111 AND data_byte - maska
	ldi r25,0b00001111
	AND r25,data_byte ; 0b01110000 AND data_byte - maska
	;;=================================================
ret


CzytajMin:
	;---------------------------
	;odczytaj z RAM
	ldi command_byte,	CMD | CLOCK | ADDR_MIN | READ		; komenda usuwajca WP
	clr data_byte		 									;tu beda dane odczytane
	rcall DS1302_SendCode
	clr command_byte
	;---------------------------

	;;=================================================
	;wydobdz informacje
	clr r26
	clr r27
	;---------------------------
	;dziesiatki
	ldi r26,0b01110000 
	AND r26,data_byte ; 0b01110000 AND data_byte - maska
	LSR	r26
	LSR	r26
	LSR	r26
	LSR	r26

	;---------------------------
	;jednosci
	;ldi r22, 0b00001111 & data_byte; 0b00001111 AND data_byte - maska
	ldi r27,0b00001111
	AND r27,data_byte ; 0b01110000 AND data_byte - maska
	;;=================================================
ret;

CzytajHrs:
	;---------------------------
	;odczytaj z RAM
	ldi command_byte,	CMD | CLOCK | ADDR_HRS | READ		; komenda usuwajca WP
	clr data_byte		 									;tu beda dane odczytane
	rcall DS1302_SendCode
	clr command_byte
	;---------------------------

	;;=================================================
	;wydobdz informacje
	clr r28
	clr r29
	;---------------------------
	;dziesiatki
	ldi r28,0b00110000 
	AND r28,data_byte ; 0b01110000 AND data_byte - maska
	LSR	r28
	LSR	r28
	LSR	r28
	LSR	r28

	;---------------------------
	;jednosci
	;ldi r22, 0b00001111 & data_byte; 0b00001111 AND data_byte - maska
	ldi r29,0b00001111
	AND r29,data_byte ; 0b01110000 AND data_byte - maska
	;;=================================================
ret;
;-----------------------------------------------------------------------------
.exit
